# readme_udf_lambda

>###   1. 自定义算子函数列表：
>> 函数名|函数说明|调用举例
>> :-|:-|:-
>> sm_sc.<br>ufv_query_by_width_row_idx_from_col         |按列检索元素。<br>在入参一的高宽平面上，按照入参二的索引序号，逐列获取索引位置的元素。<br>入参：<br>&nbsp;&nbsp;1. 元素全集；<br>&nbsp;&nbsp;2. 索引序号； |select&nbsp;&nbsp;<br>&nbsp;&nbsp;&nbsp;&nbsp;array_dims<br>&nbsp;&nbsp;&nbsp;&nbsp;(<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;sm_sc.ufv_query_by_width_row_idx_from_col<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(&nbsp;&nbsp;<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;sm_sc.fv_new_rand(array[2,&nbsp;&nbsp;3,&nbsp;&nbsp;5])&nbsp;&nbsp;<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;,&nbsp;&nbsp;((sm_sc.fv_new_rand(array[1,&nbsp;&nbsp;5])&nbsp;&nbsp;*\`&nbsp;&nbsp;3.0&nbsp;&nbsp;::&nbsp;&nbsp;float)&nbsp;&nbsp;::&nbsp;&nbsp;decimal[]&nbsp;&nbsp;+\`&nbsp;&nbsp;0.5&nbsp;&nbsp;~=\`&nbsp;&nbsp;0)&nbsp;&nbsp;::&nbsp;&nbsp;int[]<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;)<br>&nbsp;&nbsp;&nbsp;&nbsp;)<br>&nbsp;&nbsp;&nbsp;&nbsp;<br>返回:<br>&nbsp;&nbsp;&nbsp;&nbsp;[1:2][1:1][1:5]
>> sm_sc.<br>ufv_query_by_heigh_col_idx_from_row         |按行检索元素。<br>在入参一的高宽平面上，按照入参二的索引序号，逐行获取索引位置的元素。<br>入参：<br>&nbsp;&nbsp;1. 元素全集；<br>&nbsp;&nbsp;2. 索引序号； |select&nbsp;&nbsp;<br>&nbsp;&nbsp;&nbsp;&nbsp;array_dims<br>&nbsp;&nbsp;&nbsp;&nbsp;(<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;sm_sc.ufv_query_by_heigh_col_idx_from_row<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(&nbsp;&nbsp;<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;sm_sc.fv_new_rand(array[2,&nbsp;&nbsp;2,&nbsp;&nbsp;3,&nbsp;&nbsp;5])&nbsp;&nbsp;<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;,&nbsp;&nbsp;((sm_sc.fv_new_rand(array[3,&nbsp;&nbsp;1])&nbsp;&nbsp;*\`&nbsp;&nbsp;5.0&nbsp;&nbsp;::&nbsp;&nbsp;float)&nbsp;&nbsp;::&nbsp;&nbsp;decimal[]&nbsp;&nbsp;+\`&nbsp;&nbsp;0.5&nbsp;&nbsp;~=\`&nbsp;&nbsp;0)&nbsp;&nbsp;::&nbsp;&nbsp;int[]<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;)<br>&nbsp;&nbsp;&nbsp;&nbsp;)<br><br>返回:<br>&nbsp;&nbsp;&nbsp;&nbsp;[1:2][1:2][1:3][1:1]
>> sm_sc.<br>ufv_prod_mx_slice                           |入参一的宽与入参二的高不一致的矩阵乘法。<br>入参一宽、入参二高取较小的长度当做矩阵乘法宽高对齐。<br>宽高超出部分舍弃，只取对齐部分的切片参与矩阵乘法。<br>入参：<br>&nbsp;&nbsp;1. 矩阵乘法左矩阵；<br>&nbsp;&nbsp;2. 矩阵乘法右矩阵；|select&nbsp;&nbsp;<br>&nbsp;&nbsp;&nbsp;&nbsp;array_dims<br>&nbsp;&nbsp;&nbsp;&nbsp;(<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;sm_sc.ufv_prod_mx_slice<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;sm_sc.fv_new_rand(array[3,5])<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;,&nbsp;&nbsp;sm_sc.fv_new_rand(array[8,6])<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;)<br>&nbsp;&nbsp;&nbsp;&nbsp;)<br>&nbsp;&nbsp;&nbsp;&nbsp;<br>返回:&nbsp;&nbsp;<br>&nbsp;&nbsp;&nbsp;&nbsp;[1:3][1:6]
>> sm_sc.<br>ufv_prod_mx_based_org_chunk                 |左上角直传优化的矩阵乘法。<br>入参：<br>&nbsp;&nbsp;1. 矩阵乘法左矩阵；<br>&nbsp;&nbsp;2. 矩阵乘法右矩阵；<br>&nbsp;&nbsp;3. 矩阵乘法结果的左上切块的入参一切片的宽度，<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;也即入参二切片的宽度；<br>&nbsp;&nbsp;4. 矩阵乘法结果的左上切块；|select&nbsp;&nbsp;<br>&nbsp;&nbsp;&nbsp;&nbsp;sm_sc.ufv_prod_mx_based_org_chunk<br>&nbsp;&nbsp;&nbsp;&nbsp;(<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;array[[1,2,3],[4,5,6],[7,8,9]]<br>&nbsp;&nbsp;&nbsp;&nbsp;,&nbsp;&nbsp;array[[9,8,7],[6,5,4],[3,2,1]]<br>&nbsp;&nbsp;&nbsp;&nbsp;,&nbsp;&nbsp;2<br>&nbsp;&nbsp;&nbsp;&nbsp;,&nbsp;&nbsp;array[[1,2],[4,5]]&nbsp;&nbsp;\|\*\*\|&nbsp;&nbsp;array[[9,8],[6,5]]<br>&nbsp;&nbsp;&nbsp;&nbsp;)<br><br>返回:&nbsp;&nbsp;<br>&nbsp;&nbsp;&nbsp;&nbsp;array[[30,24,18],[84,69,54],[138,114,90]]

>>###   2. 自定义算子求导函数列表：
>> 函数名|函数说明|调用举例
>> :-|:-|:-
>> sm_sc.<br>ufv_d_query_by_width_row_idx_from_col_dloss_dindepdt_1  |按列检索元素函数的损失函数对第一自变量求导。<br>入参：<br>&nbsp;&nbsp;1. 损失函数对因变量的导数；<br>&nbsp;&nbsp;2. 第一自变量规格；<br>&nbsp;&nbsp;2. 第二自变量；|select&nbsp;&nbsp;<br>&nbsp;&nbsp;&nbsp;&nbsp;array_dims<br>&nbsp;&nbsp;&nbsp;&nbsp;(<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;sm_sc.ufv_d_query_by_width_row_idx_from_col_dloss_dindepdt_1<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(&nbsp;&nbsp;<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;sm_sc.fv_new_rand(array[2,&nbsp;&nbsp;2,&nbsp;&nbsp;1,&nbsp;&nbsp;5])&nbsp;&nbsp;<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;,&nbsp;&nbsp;array[2,&nbsp;&nbsp;2,&nbsp;&nbsp;3,&nbsp;&nbsp;5]<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;,&nbsp;&nbsp;((sm_sc.fv_new_rand(array[1,&nbsp;&nbsp;5])&nbsp;&nbsp;*\`&nbsp;&nbsp;3.0&nbsp;&nbsp;::&nbsp;&nbsp;float)&nbsp;&nbsp;::&nbsp;&nbsp;decimal[]&nbsp;&nbsp;+\`&nbsp;&nbsp;0.5&nbsp;&nbsp;~=\`&nbsp;&nbsp;0)&nbsp;&nbsp;::&nbsp;&nbsp;int[]<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;)<br>&nbsp;&nbsp;&nbsp;&nbsp;)<br><br>返回:<br>&nbsp;&nbsp;&nbsp;&nbsp;[1:2][1:2][1:3][1:5]
>> sm_sc.<br>ufv_d_query_by_heigh_col_idx_from_row_dloss_dindepdt_1  |按行检索元素函数的损失函数对第一自变量求导。<br>入参：<br>&nbsp;&nbsp;1. 损失函数对因变量的导数；<br>&nbsp;&nbsp;2. 第一自变量规格；<br>&nbsp;&nbsp;2. 第二自变量；|select&nbsp;&nbsp;<br>&nbsp;&nbsp;&nbsp;&nbsp;array_dims<br>&nbsp;&nbsp;&nbsp;&nbsp;(<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;sm_sc.ufv_d_query_by_heigh_col_idx_from_row_dloss_dindepdt_1<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(&nbsp;&nbsp;<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;sm_sc.fv_new_rand(array[2,&nbsp;&nbsp;3,&nbsp;&nbsp;2,&nbsp;&nbsp;1])&nbsp;&nbsp;<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;,&nbsp;&nbsp;array[2,&nbsp;&nbsp;3,&nbsp;&nbsp;2,&nbsp;&nbsp;5]<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;,&nbsp;&nbsp;((sm_sc.fv_new_rand(array[2,&nbsp;&nbsp;3,&nbsp;&nbsp;2,&nbsp;&nbsp;1])&nbsp;&nbsp;*\`&nbsp;&nbsp;5.0&nbsp;&nbsp;::&nbsp;&nbsp;float)&nbsp;&nbsp;::&nbsp;&nbsp;decimal[]&nbsp;&nbsp;+\`&nbsp;&nbsp;0.5&nbsp;&nbsp;~=\`&nbsp;&nbsp;0)&nbsp;&nbsp;::&nbsp;&nbsp;int[]<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;)<br>&nbsp;&nbsp;&nbsp;&nbsp;)<br><br>返回:<br>&nbsp;&nbsp;&nbsp;&nbsp;[1:2][1:3][1:2][1:5]

>###   3. 自定义算子运算符列表：
>> 运算符|运算符位置|运算符说明|举例
>> :-|:-|:-|:-
<!--
>> \+\`      |双目      |点(广播)加。                       <br>等价函数: sm_sc.fv_opr_add                       |select <br>&nbsp;&nbsp;array[[1.3, -8.8],[2.2, -3.0]]    <br>&nbsp;&nbsp;\+\`        <br>&nbsp;&nbsp;array[[-2.6, 11.3],[-4.6, 5.1]];    <br><br>返回：<br>&nbsp;&nbsp;array[[-1.3, 2.5],[-2.4, 2.1]]
-->

>###  4. 自定义算子配置说明
>
>> lambda 命名，即运算类型|调用函数|运算目数|是否配置协参|是否支持求导|求导函数|是否求因变量对自变量导数|求导是否需要自变量|求导是否需要另一自变量|求导是否需要因变量|求导是否用到自变量高宽规格|训练集输入集合是否变化
>> :-|:-|:-|:-|:-|:-|:-|:-|:-|:-|:-|:-
>> 81_query_from_col                   |sm_sc.<br>ufv_query_by_width_row_idx_from_col |2 | |是，当前不支持第二目|第一目:<br>&nbsp;&nbsp;sm_sc.<br>ufv_d_query_by_width_row_idx_from_col_dloss_dindepdt_1|                |  |是|  |是|
>> 81_query_from_row                   |sm_sc.<br>ufv_query_by_heigh_col_idx_from_row |2 | |是，当前不支持第二目|第一目:<br>&nbsp;&nbsp;sm_sc.<br>ufv_d_query_by_heigh_col_idx_from_row_dloss_dindepdt_1|                |  |是|  |是|
>> 81_prod_mx_slice_no_backward   |sm_sc.<br>ufv_prod_mx_slice |2 | |否||                |  |  |  |  |
>> 81_prod_mx_chunk   |sm_sc.<br>ufv_prod_mx_based_org_chunk |3 | |否||                |  |  |  |  |